<?php

# -- BEGIN LICENSE BLOCK ----------------------------------
# This file is part of Fpdf4dc2, a plugin for Dotclear 2.
# 
# ecrit par R Hackert 2020-2021
# remi.hackert(at)wanadoo.fr
# 
# Licensed under the GPL version 2.0 license.
# A copy of this license is available in LICENSE file or at
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
# -- END LICENSE BLOCK ------------------------------------


if (!defined('DC_CONTEXT_ADMIN')) {return;}

global $core;

# ajouter le plugin dans la liste des plugins du menu de l'administration
$_menu['Plugins']->addItem(
	# nom du lien (en anglais)
	__('fpdf4dc2'),
	# URL de base de la page d'administration
	'plugin.php?p=fpdf4dc2',
	# URL de l'image utilisée comme icône
	'index.php?pf=fpdf4dc2/icon.png',
	# expression régulière de l'URL de la page d'administration
	preg_match('/plugin.php\?p=fpdf4dc2(&.*)?$/',
		$_SERVER['REQUEST_URI']),
	# permissions nécessaires pour afficher le lien
	$core->auth->check('admin',$core->blog->id));
	
	global $msg;
	$msg='';

$core->addBehavior('adminPostsActionsPage',array('dopdfaction','adminPostsActionsPage'));

class dopdfaction 
{
   public static function adminPostsActionsPage($core,$ap)
	 {
		// Ajout de l'action à $ap
		$ap->addAction( array(__('Print') => array(__('To PDF') => 'dothepdf')) ,array('dopdfaction','donowthepdf') );
	   }
 
   public static function donowthepdf($core, $ap, $post)
   	 {
	  define('FPDF_FONTPATH','font/');
	    
	   $nomdublog='default'; 
       
	   global $core;
	   global $servername;	
	   global $blogurl;
	   global $fblogurl;
       global $y_image_bottom;
       global $output_name;
       
       global $typeofcover;
       global $couverture;
       global $pagedegarde;
    
       global $ccol;
       global $coltop;
       global $goutt;
       global $ncol;
       global $colwidth;
       
       $output_name = 'genere.pdf';
       //recuperation des settings de la page admin
       include dirname(__FILE__).'/recup_settings_page_admin.php';

       $servername = $_SERVER['SERVER_NAME'];

       $ccol=1;
       $coltop=$mh;
       $colwidth= ($lp-$md-$mg-($ncol-1)*$goutt)/$ncol;

       // Indication du blog à utiliser
	   $core->setBlog($nomdublog);

	   // query string alors url du blog moins index.php sinon rien à couper 
	if ($core->blog->system->url_scan == "query_string"){
		//alors deux possibilités soit cela finit par index.php?
	    if (strstr($core->blog->url,'index.php')) { 
		   $blogurl= substr($core->blog->url,0,-10); 
		   // fblogurl contient l'url du blog determine a partir de $urlorigine c'est a dire potentiellemnt apres une redirection
    	   // important pour Curl sinon probleme quand les safe mode sont sur 1 
	       $fblogurl=substr($urlorigine,0,strripos($urlorigine,'index.php')-1);
	    } else {
		  // url finit par /? sans le 'index.php'
		   $blogurl= substr($core->blog->url,0,-1);
		   $fblogurl=substr($urlorigine,0,strripos($urlorigine,'/?')-1);
	    }
	} else {
	  //on est en pathmode on enleve juste index.php/	
	    $blogurl = substr($core->blog->url,0,-10); 
	    $fblogurl= substr($urlorigine,0,strripos($urlorigine,'index.php')-1);
	    
	}

	   $selection = true;
	   	   
	   // ... et on peu commencer
	   $pdf= new PDF_HTML('P', 'mm', $fp);  // portrait, unit, format page
	    if ($couverture) {
	       switch ($typeofcover) { 
		   
		   case 'Page vide':
				$pdf->Addpage(); 
				
				break;
				
		   case 'Bauhaus' : 
				$pdf->Addpage();
				$pdf->SetFont('Arial','B',40);
				
				//eparpillement de rectangle aleatoire
				for ($i=1;$i<30; $i++) {
				$rx0=rand(0,200);
				$ry0=rand(0,290);
				$rw=rand(1,210);
				$rh=rand(1,290);
				$C1=rand(50,255);
				$C2=rand(50,255);
				$C3=rand(50,255);
				$pdf->SetFillColor($C1,$C2,$C3);
				$pdf->Rect($rx0,$ry0,$rx0+$rw,$ry0+$rh,'F');	
				}	
				$pdf->SetXY(55,140);
				$st = mb_convert_encoding("Un an d'activité", "Windows-1252", "UTF-8");
				$pdf->Write(2,$st);
			//	$pdf->SetXY(55,73);
			//	$pdf->Write(2,'EN');
			//	$pdf->SetXY(55,96);
			//	$pdf->Write(2,'COMMUN');
	
            //    if (($aveclogo) && ((file_exists($pathtologo)) || (file_exists('../'.$pathtologo))) ) {		
        	//       $pdf->Image($pathtologo,70,80,70,0,'jpg', $core->blog->url); }
				break;
				 
		   case 'Collage' : 
				$pdf->Addpage();
				
		        break; 
		   }
	   }	   
	   
	   if ($pagedegarde)  { $pdf->AddPage(); }
	   
	   include dirname(__FILE__).'/create_PDF_header_sommaire.php';
          
       // on recupere les id des posts   
       $posts_ids = $ap->getIDs(); 
	   // et pour chacun d'eux
	   foreach ($posts_ids as $ids) {
		   
           // on sélectionne le post correspondant
           $params['post_id']=$ids;
           $lepost = $core->blog->getPosts($params);
        
   		   // et on récupère les données de la table
		   $resume  = $lepost->post_excerpt_xhtml;
   		   $corps   = $lepost->post_content_xhtml;
           $titre   = $lepost->post_title;
         
		   // on récupère le nom et prenom dans la table user
   		   $rs= $core->getUser($lepost->user_id);
           $auteurdate = 'Par '.stripslashes(utf8_decode($rs->user_firstname)).' '.stripslashes(utf8_decode($rs->user_name));
		
		   // et on ecrit dans le pdf. partie commune avec public.php
		  // include dirname(__FILE__).'/create_PDF_sommaire_plus_billets.php';
		   
		    $resume = mb_convert_encoding($resume, "Windows-1252", "UTF-8");
            $corps  = mb_convert_encoding( $corps, "Windows-1252", "UTF-8"); 
            $titre  = mb_convert_encoding( $titre, "Windows-1252", "UTF-8");
        
          	   	
	    //si choisit par l'utilisateur on inscit le titre dans le sommaire.
        if ($sommaire && $selection){	
		    //pour cela on stocke la page et position actuelle
		    $pageactuelle= $pdf->PageNo() ;
		 
		
            // on se rend sur la page du sommaire
            $pdf->SetPage($pagedusommaire) ;     
            $pdf->SetY($positionYsommaire);
            $pdf->SetX($positionXsommaire);
        
            // on y inscrit le titre et la page 
            $pdf->SetFont($mtff,'B',$stfs);
		    $pdf->SetTextColor(0,102,153);
	        $pdf->Ln(12); 
	        $pagenum=$pageactuelle+1;
	        
	        //avant d'ecrire pendant qu'on y est ,on ajoute un lien vers la page
	        $linkref = $pdf->AddLink();
	        $pdf->SetLink($linkref,-1,$pagenum);
	        // et on ecrit
	        $pdf->Write(7,$titre.'. . .   p'.$pagenum,$linkref);	
		
		    // on stocke la nouvelle position
		    $positionYsommaire=$pdf->GetY();
            $positionXsommaire=$pdf->GetX();
            
		    //et on revient à la position actuelle dans le document
	       $pdf->SetPage($pageactuelle);
		
		}
	   	
	   	// et c'est parti!
	   	$pdf->AddPage();
	   	$ccol=1;
	  	$pdf->SetMargins($mg,$mh,$md);
  		$pdf->SetAutoPageBreak(1,$mb);
	   // $pdf->SetY($mh);
		

   		// Si logo.jpg existe dans le repertoire image du theme, alors il est affiché en haut à gauche.
	   	// avec un lien vers l' URL du blog.
       
        if (($aveclogo) && ((file_exists($pathtologo)) || (file_exists('../'.$pathtologo))) ) {		
    	//    $pdf->Image($pathtologo,$logoposx,$logoposy,$logowidth,0,'jpg', $core->blog->url); 	 
         } else { 
		    //sinon on ecrit le nom du blog
		    $pdf->SetFont($tff,'B',$tfs);
		    $pdf->SetTextColor(150,0,70);
	        $pdf->WriteHTML($blogurl);
		  }
    

		  // Titre		 
	  	  $pdf->SetFont( $mtff,'B',$mtfs);
	  	  $pdf->SetTextColor(0,102,153);
	  	  $pdf->Ln(8);
		
  	   	  // $y_image_bottom=170;
  		  $pdf->Ln(10);
          $pdf->SetLeftMargin($mg);
  		  $pdf->Write(7,$titre);
	      $pdf->Ln(15); 
          
          //$pdf->Bookmark($titre,true,0,0);
          
		  // Auteur et date
          // $pdf->SetFontSize(9);
          // $pdf->SetTextColor(255,153,0);
	      // $pdf->Ln(6);
          // $pdf->SetLeftMargin(45);
  	      // $pdf->WriteHTML($auteurdate);
	      // $pdf->Ln(10);
         // si multicolonne on le demarre ici

         if ($ncol>1) {
		   $ccol=1;	 
           $pdf->SetColMargin($ccol);
         // on memorise position du haut de la colonne  
           $pdf->Ln();
           $coltop=$pdf->GetY();
         }

         // Resume
		  if ($resume<>''){  
		    $pdf->SetTextColor(0,0,0);
		    $pdf->SetFont( $tff,'',$tfs);
		    $pdf->Ln();
	        $pdf->WriteHTML($resume); 
		   } 

	  	// Corps du texte
	  	
         $pdf->SetTextColor(0,0,0);
         $pdf->SetFont($tff,'',$tfs);
         $pdf->Ln();
         $pdf->WriteHTML($corps);
       	   
	  } //end of foreach
 	   
    	// et on envoie
	    $pdf->Output();  
   		
   		return $pdf;
   	    //$ap->redirect(true, array('upd' =>1 ));	
   }
 
}
include dirname(__FILE__).'/classePDF_HTML.php';

?>
	

