<?php
 
//conversion pixel -> millimètre en 72 dpi
function px2mm($px){
    return $px*100/72;
}
//conversion de % en mm
function pc2mm($pc){
	global $mg;
	global $md;
	global $lp;
    return $pc*($lp-$mg-$md)/100;
}

function vpc2mm($pc,$ratio){
    global $mg;
	global $md;
	global $lp;
    return $pc*($lp-$mg-$md)*$ratio/100;
}


function vmm2pc($mm,$ratio){
    global $mg;
	global $md;
	global $lp;
	return $mm*100/($ratio*($lp-$mg-$md));
}


function remove_accent($str)
{
  $utf8 = array(
'/[áàâãªä]/u' => 'a',
'/[ÁÀÂÃÄ]/u' => 'A',
'/[ÍÌÎÏ]/u' => 'I',
'/[íìîï]/u' => 'i',
'/[éèêë]/u' => 'e',
'/[ÉÈÊË]/u' => 'E',
'/[óòôõºö]/u' => 'o',
'/[ÓÒÔÕÖ]/u' => 'O',
'/[úùûü]/u' => 'u',
'/[ÚÙÛÜ]/u' => 'U',
'/ç/' => 'c',
'/Ç/' => 'C',
'/ñ/' => 'n',
'/Ñ/' => 'N',
'//' => '-', // conversion d'un tiret UTF-8 en un tiret simple
'/[]/u' => ' ', // guillemet simple
'/[«»]/u' => ' ', // guillemet double
'/ /' => ' ', // espace insécable (équiv. à 0x160)
);
return preg_replace(array_keys($utf8), array_values($utf8), $str);
} 


class PDF_HTML extends fpdf
{
//variables du parseur html
var $B;
var $I;
var $U;
var $HREF;
var $fontList;
var $issetfont;
var $issetcolor;
var $y_image_bottom=0;

var $ccol;
var $coltop;

// fonction hex2dec
// retourne un tableau associatif (clés : R,V,B) à
// partir d'un code html de couleur hexa (ex : #3FE5AA)
function hex2dec($couleur = "#52032A")
{
    $R = substr($couleur, 1, 2);
    $rouge = hexdec($R);
    $V = substr($couleur, 3, 2);
    $vert = hexdec($V);
    $B = substr($couleur, 5, 2);
    $bleu = hexdec($B);
    $tbl_couleur = array();
    $tbl_couleur['R']=$rouge;
    $tbl_couleur['V']=$vert;
    $tbl_couleur['B']=$bleu;
    return $tbl_couleur;
}

function Header()
{
 global $titre;
 global $mg;
 global $md; 
 global $mh;
 global $mb;
 global $tfs; //text font size
 global $afs; //auhor font size
 global $mtfs; //main title font size
 global $stfs ; // section title font size
 
 global $tff; //text font family
 global $aff; //auhor font family
 global $mtff; //main title font family
 global $stff ; // section title font family

 if($this->page>1)
    {
      //Police 
       $this->SetTextColor(200,200,200);
       $this->SetFont( $aff,'I',$afs);
      // echo $titre;
      //Titre
          $this->SetXY($mg,$mh/2);
	      $this->Cell2(0,0,$titre,0,0,'C');
	      $this->SetTextColor(0,0,0);
      //Saut de ligne
	    //  $this->Ln(20);  
    }
}
	
//Pied de page
function Footer()
{
	global $lp;
	global $hp;
	global $mg;
	global $md;
	global $tfs; //text font size
    global $afs; //auhor font size
    global $mtfs; //main title font size
    global $stfs ; // section title font size
    
    global $tff; //text font family
    global $aff; //auhor font family
    global $mtff; //main title font family
    global $stff ; // section title font family

    // $this->SetFillColor(150,0,0);
    // $this->Rect($mg,$hp-10,$lp-$mg-$md,0.25,'F');
	//Positionnement à 1,5 cm du bas
	$this->SetY(-7);
    $this->SetLeftMargin($mg);
	//Police Arial italique 8
	$this->SetFont('Arial','I',8);
	$this->SetTextColor(200,200,200);
	//Numéro de page
	if ($this->PageNo()>1)
	      $this->Cell2($lp-$mg-$md,0,'Page '.$this->PageNo(),0,0,'C');
}

// multicolonne: en construction
function SetColMargin($col)
{
    global $mg;
    global $md; 
    global $mh;
    global $mb;
    global $lp;
    
    global $indent;
    
    global $ncol;
    global $ccol;
    global $goutt;
    global $colwidth;
    	
  if ($this->PageNo() % 2 == 1){ //page de droite 
    // mg marge interieure, md marge exterieure
    if ($ncol==1) {
	    $this->lMargin=$mg;
        $this->rMargin=$md;
    } else {
    // Set position at a given column
    $ccol = $col;
    $this->lMargin=$mg+($col-1)*($colwidth+$goutt)+$indent;
    $this->rMargin=$lp-($mg+$col*$colwidth+($col-1)*$goutt);
   }
   
  } else {
	
	//page de gauche
    // mg marge exterieure, md marge interieure
    if ($ncol==1) {
	    $this->lMargin=$md;
        $this->rMargin=$mg;
    } else {
    // Set position at a given column
    $ccol = $col;
    $this->lMargin=$md+($col-1)*($colwidth+$goutt)+$indent;
    $this->rMargin=$lp-($md+$col*$colwidth+($col-1)*$goutt);
   }
     
  }  
}

function AcceptPageBreak2()
{
    global $mg;
    global $md; 
    global $mh;
    global $mb;
    
    global $ncol;
    global $ccol;
    global $coltop;

    // Method accepting or not automatic page break
    if($ccol<$ncol)
    {
        // Go to next column
        $ccol=$ccol+1;
        $this->SetColMargin($ccol);
        // Set ordinate to top
        $this->SetY($coltop);
        // Keep on page
        return false;
    } else {
        // Go back to first column      
        $ccol=1;
        $this->SetColMargin($ccol);
        $coltop=$mh;    
        // Page break
        $this->AutoPageBreak;
        return true;
    }
}
// fin multicolonne en construction=


function PDF_HTML($orientation='P', $unit='mm', $format)
{
    //Appel au constructeur parent
    $this->__construct($orientation,$unit,$format);
    //Initialisation
    $this->B=0;
    $this->I=0;
    $this->U=0;
    $this->HREF='';
    $this->fontlist  = array('arial', 'times', 'courier', 'helvetica', 'symbol');
    $this->issetfont = false;
    $this->issetcolor= false;
}

function Cell2($w, $h=0, $txt='', $border=0, $ln, $align='', $fill=false, $link='')
{
 global $lastposx; 
 global $lastposy; 
 global $y_image_bottom;
 global $mg;
 global $md; 
 global $mh;
 global $mb;
 global $hp;


	//Output a cell
	$k=$this->k;
	if($this->y+$h>$this->PageBreakTrigger && !$this->InHeader && !$this->InFooter && $this->AcceptPageBreak2())
	{
		//Automatic page break
		$x=$this->x;
		$ws=$this->ws;
		if($ws>0)
		{
			$this->ws=0;
			$this->_out('0 Tw');
		}

        // on preserve l'indentation lors du changement de page
       // en mode unicolonne
        $ltmp=$this->lMargin;
        $rtmp=$this->rMargin;   	
        $this->AddPage($this->CurOrientation,$this->CurPageFormat,$this->CurRotation);
        if ($ncol==1) {       
        $this->lMargin=$ltmp;
        $this->rMargin=$rtmp;
        $this->x=$x;
        } else {
		$ccol=1;	
		$this->SetColMargin(1);
		$this->x=$mg;	
		}	
  		$y_image_bottom=0;
  	    $this->SetY($mh);
  	    	    
		
		if($ws>0)
		{
			$this->ws=$ws;
			$this->_out(sprintf('%.3F Tw',$ws*$k));
		}
	}
	if($w==0)
		$w=$this->w-$this->rMargin -$this->x;
	$s='';
	if($fill || $border==1)
	{
		if($fill)
			$op=($border==1) ? 'B' : 'f';
		else
			$op='S';
		$s=sprintf('%.2F %.2F %.2F %.2F re %s ',$this->x*$k,($this->h-$this->y)*$k,$w*$k,-$h*$k,$op);
	}
	if(is_string($border))
	{
		$x=$this->x;
		$y=$this->y;
		
		if(strpos($border,'L')!==false)
			$s.=sprintf('%.2F %.2F m %.2F %.2F l S ',$x*$k,($this->h-$y)*$k,$x*$k,($this->h-($y+$h))*$k);
		if(strpos($border,'T')!==false)
			$s.=sprintf('%.2F %.2F m %.2F %.2F l S ',$x*$k,($this->h-$y)*$k,($x+$w)*$k,($this->h-$y)*$k);
		if(strpos($border,'R')!==false)
			$s.=sprintf('%.2F %.2F m %.2F %.2F l S ',($x+$w)*$k,($this->h-$y)*$k,($x+$w)*$k,($this->h-($y+$h))*$k);
		if(strpos($border,'B')!==false)
			$s.=sprintf('%.2F %.2F m %.2F %.2F l S ',$x*$k,($this->h-($y+$h))*$k,($x+$w)*$k,($this->h-($y+$h))*$k);
	}
	if($txt!=='')
	{
		if($align=='R')
			$dx=$w-$this->cMargin-$this->GetStringWidth($txt);
		elseif($align=='C')
			$dx=($w-$this->GetStringWidth($txt))/2;
		else
			$dx=$this->cMargin;
		if($this->ColorFlag)
			$s.='q '.$this->TextColor.' ';
		
		//	quelques substitutions pour permettre aux parenthèses d'etre imprimées das le pdf
	//	$txt2=str_replace(')','\\)',str_replace('(','\\(',str_replace('\\','\\\\',$txt)));
		
		$s.=sprintf('BT %.2F %.2F Td (%s) Tj ET',($this->x+$dx)*$k,($this->h-($this->y+.5*$h+.3*$this->FontSize))*$k,$this->_escape($txt));
		
		// on se memore la position
  
		$lastposx=$this->x + $this->GetStringWidth($txt); 
		$lastposy=$this->y;
		
		if($this->underline)
			$s.=' '.$this->_dounderline($this->x+$dx,$this->y+.5*$h+.3*$this->FontSize,$txt);
		if($this->ColorFlag)
			$s.=' Q';
		if($link)
			$this->Link($this->x+$dx,$this->y+.5*$h-.5*$this->FontSize,$this->GetStringWidth($txt),$this->FontSize,$link);
	}
	if($s)
		$this->_out($s);
	$this->lasth=$h;
	if($ln>0)
	{
		//Go to next line
		$this->y+=$h;
		if($ln==1)
			$this->x=$this->lMargin;
	}
	else
 $this->x+=$w;
}


function MultiCell2($w, $h, $txt,$border=0, $align='J', $fill=false, $maxline=1)
{
 	global $lastposx;
 	global $lastposy;
    global $mg;
    global $md; 
    global $mh;
    global $mb;


        //Output text with automatic or explicit line breaks, at most $maxline lines
        $cw=&$this->CurrentFont['cw'];
        if($w==0)
            $w=$this->w-$this->rMargin-$this->x;
        $wmax=($w-2*$this->cMargin)*1000/$this->FontSize;
        $s=str_replace("\r",'',$txt);
        $nb=strlen($s);
        if($nb>0 && $s[$nb-1]=="\n")
            $nb--;
        $b=0;
       if($border)
	{
		if($border==1)
		{
			$border = 'LTRB';
			$b = 'LRT';
			$b2 = 'LR';
		}
		else
		{
			$b2 = '';
			if(strpos($border,'L')!==false)
				$b2 .= 'L';
			if(strpos($border,'R')!==false)
				$b2 .= 'R';
			$b = (strpos($border,'T')!==false) ? $b2.'T' : $b2;
		}
	}
        $sep=-1;
        $i=0;
        $j=0;
        $l=0;
        $ns=0;
        $nl=1;
        while($i<$nb)
        {
            //Get next character
            $c=$s[$i];
            if($c=="\n")
            {
                //Explicit line break
                if($this->ws>0)
                {
                    $this->ws=0;
                    $this->_out('0 Tw');
                }
                $this->Cell2($w,$h,substr($s,$j,$i-$j),$b,2,$align,$fill,'');
                $i++;
                $sep=-1;
                $j=$i;
                $l=0;
                $ns=0;
                $nl++;
               
                if ( $maxline && $nl > $maxline ) 
                    return substr($s,$i);
                continue;
            }
            if($c==' ')
            {
                $sep=$i;
                $ls=$l;
                $ns++;
            }
            $l+=$cw[$c];
            if($l>$wmax)
            {
                //Automatic line break
                if($sep==-1)
                {
                    if($i==$j)
                        $i++;
                    if($this->ws>0)
                    {
                        $this->ws=0;
                        $this->_out('0 Tw');
                    }
                    $this->Cell2($w,$h,substr($s,$j,$i-$j),$b,1,$align,$fill,''); 
                }
                else
                {
                    if($align=='J')
                    {
                        $this->ws=($ns>1) ? ($wmax-$ls)/1000*$this->FontSize/($ns-1) : 0;
                        $this->_out(sprintf('%.3F Tw',$this->ws*$this->k));
                    }
                    $this->Cell2($w,$h,substr($s,$j,$sep-$j),$b,1,$align,$fill,''); 
                    $i=$sep+1;
                }
                $sep=-1;
                $j=$i;
                $l=0;
                $ns=0;
                $nl++;
               
                if ( $maxline && $nl > $maxline ) 
                    return substr($s,$i);
            }
            else
                $i++;
        }
        //Last chunk
        if($this->ws>0)
        {
            $this->ws=0;
            $this->_out('0 Tw');
        }
      
        $this->Cell2($w,$h,substr($s,$j,$i-$j),$b,0,$align,$fill,'');
        $this->x=$this->lMargin;
        return '';
}

function WriteHTML($html)
{
    global $y_image_bottom;
    global $lastposx;
    global $lastposy;
    global $margegauche;
    global $margedroite;
    global $mg;
    global $md; 
    global $mh;
    global $mb;
    global $ncol;
    global $colwidth;
    global $il;
     
    global $char_count; //compte les caracteres restant a imprimer
    
   
    $lastposx = $this->GetX();
    $lastposy = $this->GetY();

    //Parseur HTML
   	//supprime tous les tags sauf ceux reconnus
   	$html=str_replace("\n",' ',$html); //remplace retour à la ligne par un espace
    $html=strip_tags($html,"<b><u><i><a><img><p><br><code><strong><em><font><tr><blockquote><h1><h2><h3><h4><h5><h6><li><ul><figure><figcaption><aside><section>"); 
    
    //$char_count= WordWrap($html,$colwidth*$ncol);
    
    $a=preg_split('/<(.*)>/U',$html,-1,PREG_SPLIT_DELIM_CAPTURE); //éclate la chaîne avec les balises
    foreach($a as $i=>$e)
    {
      if($i%2==0)
       {
        //Texte
        if($this->HREF) {
            $this->y=$lastposy;
            $this->x=$lastposx;
            $this->PutLink($this->HREF,$e);
       //       echo 'coltop4='.$this->GetY();
        } else {
		      // on envoie le texte ligne par ligne
		      $trans = get_html_translation_table(HTML_ENTITIES);
              $trans = array_flip($trans);
              $tmp = strtr($e, $trans);
		
              while($tmp!=''){
		        $tmp=$this->MultiCell2(0,$il,$tmp,0,'J',false,1);
	          		// teste si on a depasse la fin de la derniere image affichée à gauche
          			if(($this->GetY()>$y_image_bottom) && ($y_image_bottom>0)){  
			          	 $this->SetColMargin($ccol);
			          	 $this->y=$this->GetY();
			          
		          		 $y_image_bottom=0;
		         		 } 
		         }
	       }
      }
      else
      {
            //Balise
            if($e[0]=='/')
                $this->CloseTag(strtoupper(substr($e,1)));
            else
            {
                //Extraction des attributs
	                	$f=str_replace(": ",'="',$e);
		           //   $f=str_replace(":",'="',$f); //pose probleme avec les url
		                $f=str_replace(";",'";',$f);
		                $f=str_replace(";",' ',$f);
		                $f=str_replace('style="','',$f);
	                	$f=str_replace('" ',' ',$f);
                $a2=explode(' ',$f);       
	              	$tag=strtoupper(array_shift($a2));
		
                $attr=array();
                foreach($a2 as $v)
                {
                    if(preg_match('/([^=]*)=["\']?([^"\']*)/',$v,$a3))
                        $attr[strtoupper($a3[1])]=$a3[2];
                }
                $this->OpenTag($tag,$attr);
               // echo $tag.'   '.$attr['HREF'];
            }
        }
    }
}


function OpenTag($tag, $attr)
{
  
    global $lastposx;
    global $lastposy;
    global $y_image_bottom;
    global $blogurl;
    global $fblogurl;
    global $servername;
    global $mg;
    global $md; 
    global $mh;
    global $mb;
    global $hp;
    global $lp;
    global $indent;
   
    global $tfs; //text font size
    global $afs; //auhor font size
    global $mtfs; //main title font size
    global $stfs ; // section title font size
    global $tff; //text font family
    global $aff; //auhor font family
    global $mtff; //main title font family
    global $stff ; // section title font family
    global $il; //interligne
 
    global $ncol;
    global $ccol;
    global $colwidth;
    global $goutt;
    global $coltop;
    
    
    //Balise ouvrante
    
    switch($tag){
        case 'STRONG':  
            $this->SetStyle('B',true);
            $this->y=$lastposy;
            $this->x=$lastposx;
            break;
        case 'B': 
            $this->SetStyle('B',true);
            $this->y=$lastposy;
            $this->x=$lastposx;
            break;
        case 'EM':
        case 'I':
            $this->y=$lastposy;
            $this->x=$lastposx;
            $this->SetStyle('I',true);
            break;
        case 'U':
            //$this->y-=5;
            $this->y=$lastposy;
            $this->x=$lastposx;
            $this->SetStyle('U',true);
            break;
        case 'A':
            $this->HREF=$attr['HREF'];
            break;
            
        case 'FIGURE':
         //   $this->Ln(1);
            break;
        case 'IMG': 	
            if(isset($attr['SRC'])) {
				
		     if (strstr($attr['SRC'],'public')) {
		     $file0 = substr($attr['SRC'],strripos($attr['SRC'],'public')); }
		     if (strstr($attr['SRC'],'themes')) {
		     $file0 = substr($attr['SRC'],strripos($attr['SRC'],'themes'));}  

			 // on determine le ratio de l'image	        	
	         $ratio=0;
	        
	         // Curl a besoin d'une url complete
	         if (strstr($attr['SRC'],'http')) { 
				$filepath = $attr['SRC']; 
             } else { 
				$filepath = $blogurl. substr($attr['SRC'],strpos($attr['SRC'],'public'));     
			 }
 
             $pos = strrpos($filepath,'.');
		     if(!$pos){ $this->Error('Image file has no extension and no type was specified: '.$filepath); }
       
         
             $imtype = strtolower(substr($filepath,$pos+1));
		     if ($imtype == 'jpeg') $imtype='jpg';
           
             if (!isset($ch)) $ch = curl_init();    
     	       $timeout = 0; // set to zero for no timeout
	           curl_setopt ($ch, CURLOPT_BINARYTRANSFER, 1);
               curl_setopt ($ch, CURLOPT_URL, $filepath);
	           curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
               curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
               $image = curl_exec($ch);
	         curl_close($ch);
	             
	         $new_image = imagecreatefromstring($image);
	            
             $ratio = imagesy($new_image) / imagesx($new_image);	
           
             if(!isset($attr['HEIGHT']))
                    $attr['HEIGHT'] = 0;   
           
             if ($ncol==1){   
				if(!isset($attr['WIDTH'])){
                  $attr['WIDTH'] = intval(50*$colwidth/($lp-$md-$mg));
				} else {
				//	$attr['WIDTH'] = intval(50*$colwidth/($lp-$md-$mg));
				  $attr['WIDTH'] = str_replace('%','',$attr['WIDTH']); 
				}
			    //on verifie si cette image tient verticalement sur la page
				if (vpc2mm($attr['WIDTH'], $ratio)>($hp-$mb-$mh)) {		
					//sinon on adapte la largeur pour obtenir la hauteur maxi acceptable
					$attr['WIDTH']=(100*($hp-$mb-$mh))/(($lp-$md-$mg)*$ratio);	
				}
				
				// si a gauche ou a droite deja une image on saute en dessous
				if ($this->GetY() < $y_image_bottom) { 
				// pour aerer un peu on rajoute un interligne 
					$this->SetY($y_image_bottom+$il); 
					$this->SetMargins($mg,$mb,$md);
				}
				
			    // Si pas assez de place sur cette page, ....
				if (($this->GetY()+vpc2mm($attr['WIDTH'],$ratio))>($hp-$mb)){ 

			   // on vérifie qu'on est pas en bas de page
				if (($hp-$this->GetY())<$mb) {
					$this->AddPage();
					$this->SetColMargin(1);
					$y_image_bottom=0; 
					$this->y=$mh;  
				} else {
	    		   // on teste si en reduisant un peu ca peut rentrer sinon on change de page
			       if (vmm2pc($hp-$mb-$this->GetY(),$ratio)<50){
					  $this->AddPage();
					  $this->SetColMargin(1); 
					  $y_image_bottom=0; 
					  $this->y=$mh;
					  $lastposy=$mh;
				   } else {
                      $attr['WIDTH'] = vmm2pc($hp-$mb-$this->getY(),$ratio);
				   }
				}
				
				
				}    
                $this->y=$this->GetY();
	            $lastposy=$this->y; 
 
                if ($attr['FLOAT']=='left') {
				  $evodmg=($mg*($this->PageNo()%2))+($md*(1-($this->PageNo()%2)));  
            	  $this->Image($file0,$evodmg, $this->y, pc2mm($attr['WIDTH']), pc2mm($attr['HEIGHT']),$imtype,$this->HREF);
            	  if ($attr['WIDTH']<75){
            	     $this->lMargin = $evodmg + $il + intval(pc2mm($attr['WIDTH']));		
			         $lastposx=$this->lMargin; 
			         $y_image_bottom =  $this->GetY()+ vpc2mm($attr['WIDTH'],$ratio)+$il;
			         $this->y=$lastposy;
			      } else  {
					 $this->y = $this->GetY()+ vpc2mm($attr['WIDTH'],$ratio) + $il;	
					 $lastposy=$this->y;
					 $y_image_bottom=0;
				  }	  

				} else {
                // alors c'est float=right ou pas de float 

				  $evodmd= $md*($this->PageNo()%2)+$mg*(1-($this->PageNo()%2));
		    	  $this->Image($file0, $lp-$evodmd-pc2mm($attr['WIDTH']), $this->y, pc2mm($attr['WIDTH']), pc2mm($attr['HEIGHT']),$imtype,$this->HREF);
		    	  if ($attr['WIDTH']<75){
		    	       $this->rMargin = $evodmd + $il + intval(pc2mm($attr['WIDTH']));	
			           $lastposx=$this->lMargin; 
			           $y_image_bottom =  $this->GetY()+ vpc2mm($attr['WIDTH'],$ratio)+$il;
			           $this->y=$lastposy;
			      }  else {
					  $this->y = $this->GetY()+ vpc2mm($attr['WIDTH'],$ratio) + $il;	
					  $lastposy=$this->y;
					  $y_image_bottom=0;
				  }
				
			    }
	
                      
		     }
            
                  
		     if ($ncol>1){
			   
			   $this->y=$this->GetY()+2;
				$lastposy=$this->y; 
				//si on est en haut de la colonne on detoure pas
		//		echo 'coltop5='.$this->GetY();
				
				
				if (isset($attr['CLASS'])) {
						 if ($attr['CLASS']=="kinorama"  ){ 
							$attr['WIDTH']=intval(100*$lp/($lp-$mg-$md));
							$lastposy=$this->GetY();
							$this->Image($file0,0, $this->GetY(), pc2mm($attr['WIDTH']), pc2mm($attr['HEIGHT']),$imtype,$this->HREF);				
							$y_image_bottom =  0;
							$coltop= $this->GetY()+ vpc2mm($attr['WIDTH'],$ratio)+$il;
							$this->y = $coltop;
							$lastposy=$this->GetY();
						 }
					     if ($attr['CLASS']=="overallcol"){ 
							$attr['WIDTH']=intval(100);
							$lastposy=$this->GetY();
							$evodmg=($mg*($this->PageNo()%2))+($md*(1-($this->PageNo()%2)));
							$this->Image($file0,$evodmg, $this->GetY(), pc2mm($attr['WIDTH']), pc2mm($attr['HEIGHT']),$imtype,$this->HREF);				
							$y_image_bottom =  0;
							$coltop= $this->GetY()+ vpc2mm($attr['WIDTH'],$ratio)+$il;
							$this->y = $coltop;
							$lastposy=$this->GetY();
							}
					     if ($attr['CLASS']=="overcol12" ) { 
							$attr['WIDTH']=intval(100*(2*$colwidth+$goutt)/($lp-$mg-$md));
							$lastposy=$this->GetY();
							$attr['FLOAT']='left';
							$evodmg=($mg*($this->PageNo()%2))+($md*(1-($this->PageNo()%2)));
							$this->Image($file0,$evodmg, $this->GetY(), pc2mm($attr['WIDTH']), pc2mm($attr['HEIGHT']),$imtype,$this->HREF);				
							$y_image_bottom =  0;
							$coltop= $this->GetY()+ vpc2mm($attr['WIDTH'],$ratio)+$il;
							$this->y = $coltop;
							$lastposy=$this->GetY();
							}
					     if ($attr['CLASS']=="overcol23" ){ 
							$attr['WIDTH']=intval(100*(2*$colwidth+$goutt)/($lp-$mg-$md));
							$lastposy=$this->GetY();
							$attr['FLOAT']='right';
							$evodmg=($mg*($this->PageNo()%2))+($md*(1-($this->PageNo()%2)));
							if ($ncol>=3) {
								$this->Image($file0,$evodmg+$colwidth+$goutt, $this->GetY(), pc2mm($attr['WIDTH']), pc2mm($attr['HEIGHT']),$imtype,$this->HREF);				
							} else { 
								$this->Image($file0,$evodmd, $this->GetY(), pc2mm($attr['WIDTH']), pc2mm($attr['HEIGHT']),$imtype,$this->HREF);
							}
							$y_image_bottom =  0;
							$coltop= $this->GetY()+ vpc2mm($attr['WIDTH'],$ratio)+$il;
							$this->y = $coltop;
							$lastposy=$this->GetY();
						}	
				} else {
						$attr['WIDTH'] = floor(100*$colwidth/($lp-$md-$mg));
						$this->Image($file0,$this->lMargin, $this->y, pc2mm($attr['WIDTH']), pc2mm($attr['HEIGHT']),$imtype,$this->HREF);
						$this->y = $this->GetY()+ vpc2mm($attr['WIDTH'],$ratio)+ $goutt;	
						//pour maintenir un alignement des ligne des colonnes on reprend l'ecriture a un multiple de $il
						$this->y= $coltop + $il*(1+intval(($this->y -$coltop)/$il));
						$y_image_bottom=0;
						$lastposy=$this->GetY();
				}    					
	      }
		  }
          break; 
              
     case 'LI':
           $this->SetXY($this->x-2,$this->y);
           $this->Cell2(2,$il,"- ",0,0,'',false,''); 
        //   $this->Write($il,'-');   
           break;         
     case 'TR':
	 case 'UL':
	       if ($ncol==1){  
           $this->lMargin+=10; 
           $indent=$indent+10;
	       } else {
			   $this->lMargin+=3; 
               $indent=$indent+3;
           }
           $this->x =$this->lMargin;  
           break;
           
     case 'BLOCKQUOTE':
           break;
        
     case 'BR':  
           $this->Ln();
           $this->x=$this->lMargin;
         //  $this->x = $mg -1.25;
           break;
            
	 case 'CODE':
          $this->Ln($il);
          $this->SetFont('Courier','',$tfs);
          $this->SetTextColor(20,20,70);	      
		  break;
  
    case 'FIGCAPTION':
          $this->Ln(2);
          $this->SetFont($tff,'',$tfs-2);
          $this->SetTextColor(120,120,120);	      
		  break;
		
    case 'P':
     		   if ($this->GetY() > $y_image_bottom) { 
				$this->SetColMargin($ccol);   
	     		
			    }
		     	$this->x=$this->lMargin;
		     	$lastposy = $this->y;
                $lastposx = $this->x;
                
           break;
            
     case 'FONT':
            if (isset($attr['COLOR']) && $attr['COLOR']!='') {
                $coul=hex2dec($attr['COLOR']);
                $this->SetTextColor($coul['R'],$coul['V'],$coul['B']);
                $this->issetcolor=true;
            }
            if (isset($attr['FACE']) && in_array(strtolower($attr['FACE']), $this->fontlist)) {
                $this->SetFont(strtolower($attr['FACE']));
                $this->issetfont=true;
            }
            break;
        
     case 'H3': 
     case 'H4':
           // de l'espace avant que si pas en haut d'une page 
           if ($this->GetY()>$mh) $this->Ln(2*$il);
		       // Si image ,titre  en dessous.
		       if ($this->GetY() < $y_image_bottom) { 
	       		$this->SetY($y_image_bottom + 2*$il);
	       		$y_image_bottom=0; 
	       		$this->SetLeftMargin($mg);
		       	$this->SetRightMargin($md); 
           }
  		   // on verife qu'on est pas en bas de page , sinon on saute en haut de la suivante
		   if (($this->GetY()+40)>($hp-$mb)){
			 if ($ccol==$ncol) {
			       $this->AddPage(); 
			      // $this->SetColMargin(1);
                   $coltop=$mh;
                   // Page break
                 
			 } 
             $this->AcceptPageBreak2(); 
             $y_image_bottom=0; 
             //$this->SetLeftMargin($mg);
             //$this->SetRightMargin($md);
             $lastposx=$this->lMargin;
             $this->y=$coltop;
             $this->x=$this->lMargin;
           }
		   $this->SetTextColor(0,100,0);
		   $this->SetFont($stff,'B',$stfs);
		   break;     
		   
     case 'H6':
	        $this->SetFontSize(8);
		    break; 
    case 'ASIDE' :
            $this->SetFont('Arial','B',9);
            $this->SetTextColor(200,50,50);
            $indent=$indent+3;
			break;
    case 'SECTION':
          //on demarre le mode multicolonne
          // en construction
          $this->$multicolflag=true;
		  break;
    }
      
}



function CloseTag($tag)
{
    global $lastposx;
    global $lastposy;
    global $margegauche;
    global $mg;
    global $md; 
    global $mh;
    global $mb;
    global $indent;
    global $coltop;
    global $tfs; //text font size
    global $afs; //auhor font size
    global $mtfs; //main title font size
    global $stfs ; // section title font size
    global $tff; //text font family
    global $aff; //auhor font family
    global $mtff; //main title font family
    global $stff ; // section title font family
    global $il; //interligne
    
    //Balise fermante
    switch($tag){    
		       
    case 'H4':
    case 'H3': $this->Ln($il); 
              // $coltop = $this->GetY();              
    case 'H6':
    case 'FIGCAPTION':
           $this->SetStyle('B',false);
           $this->SetTextColor(0,0,0); 
           $this->SetFont($tff,'',$tfs);
           $this->Ln();
           break; 
    case 'STRONG':
         $this->x=$lastposx; 
	     $this->y=$lastposy; 
         $this->SetStyle('B',false);
	     break;  
    case 'B':
      	 $this->x=$lastposx; 
	     $this->y=$lastposy; 
         $this->SetStyle('B',false);
	     break;  
    case 'EM':  
    case 'I' :
         $this->x=$lastposx; 
	     $this->y=$lastposy; 
         $this->SetStyle('I',false);
         break;      
    case 'U' :
          $this->SetStyle('U',false);
	     $this->x=$lastposx; 
	      $this->y=$lastposy; 
	      break;  	
    case 'A':
          $this->HREF='';
       //   $this->x=$lastposx; 
	   //   $this->y=$lastposy; 
          break;
    case 'LI':
          $this->Ln(2*$il);
		  break;
    case 'UL': 
          if ($ncol==1){
          $this->lMargin-=10; 
          $indent = $indent-10;
	      } else {
			$this->lMargin-=3; 
            $indent = $indent-3;  
	      }
          $this->x= $this->lMargin;
          //$this->Ln(1);
          break;
    case 'P':
          $this->Ln(2*$il);
          break; 
    case 'CODE':
          $this->SetFont('Courrier','',$tfs);
	      $this->SetTextColor(0,0,0); 
		  $this->Ln(1);
		  break; 
    case 'FONT':
          $this->SetTextColor(0);
          $this->SetFont($tff); 
          $this->issetfont=false ; 
          break;
    case 'ASIDE' :
            $this->SetFontSize($tfs);
            $this->SetTextColor(0,0,0);
            $indent=$indent-3;
			break;      
    case 'SECTION':
         break;  
           
    }
}



function SetStyle($tag, $enable)
{
	global $lastposx;
    global $lastposy;
    
    //Modifie le style et sélectionne la police correspondante
    $this->$tag+=($enable ? 1 : -1);
    $style='';
    foreach(array('B','I','U') as $s)
    {
        if($this->$s>0)
            $style.=$s;
    }
    $this->SetFont('',$style);
}

function PutLink($URL, $txt)
{
   global $il;
   
    //Place un hyperlien
    $this->SetTextColor(0,0,255);
    //$this->SetStyle('U',true);
    $this->Write($il,$txt,$URL);
    //$this->SetStyle('U',false);
    $this->SetTextColor(0);
}

//cette fonction compte le nombre de lignes prises par un texte
//etant donnee la largeur de la colonne
//on peut donc estimer un hauteur dans laquelle nous écrirons 
//en multicolonne

function WordWrap(&$text, $maxwidth)
{
	
	$text=strip_tags($text,"<b><u><i><a><img><p><br><code><strong><em><font><tr><blockquote><h1><h2><h3><h4><h5><h6><li><ul><figure><figcaption><section>"); 
    
    $text = trim($text);
    if ($text==='')
        return 0;
    $space = $this->GetStringWidth(' ');
    $lines = explode("\n", $text);
    $text = '';
    $count = 0;

    foreach ($lines as $line)
    {
        $words = preg_split('/ +/', $line);
        $width = 0;

        foreach ($words as $word)
        {
            $wordwidth = $this->GetStringWidth($word);
            if ($wordwidth > $maxwidth)
            {
                // Word is too long, we cut it
                for($i=0; $i<strlen($word); $i++)
                {
                    $wordwidth = $this->GetStringWidth(substr($word, $i, 1));
                    if($width + $wordwidth <= $maxwidth)
                    {
                        $width += $wordwidth;
                        $text .= substr($word, $i, 1);
                    }
                    else
                    {
                        $width = $wordwidth;
                        $text = rtrim($text)."\n".substr($word, $i, 1);
                        $count++;
                    }
                }
            }
            elseif($width + $wordwidth <= $maxwidth)
            {
                $width += $wordwidth + $space;
                $text .= $word.' ';
            }
            else
            {
                $width = $wordwidth + $space;
                $text = rtrim($text)."\n".$word.' ';
                $count++;
            }
        }
        $text = rtrim($text)."\n";
        $count++;
    }
    $text = rtrim($text);
    return $count;
}


function SetPage($num) {
    $this->page = $num;
}

} //fin classe

?>
